using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Globalization;
using System.Windows.Forms;
using System.Xml;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;

namespace VirtualGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        public delegate void DummyEventHandler(object sender, DummyEventArgs args);
        public event DummyEventHandler myEvent;
        private System.Windows.Forms.Panel panel1;
        private GridControl MyGrid;
        private MyList m_InfoList = new MyList();
        private System.Windows.Forms.Button button1;

		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
            this.MyGrid = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.panel1 = new System.Windows.Forms.Panel();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.MyGrid)).BeginInit();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // MyGrid
            // 
            this.MyGrid.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)));
            this.MyGrid.ColWidths = ((Syncfusion.Windows.Forms.Grid.GridModelRowColSizeIndexer)(resources.GetObject("MyGrid.ColWidths")));
            this.MyGrid.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.MyGrid.Location = new System.Drawing.Point(0, 0);
            this.MyGrid.Name = "MyGrid";
            this.MyGrid.Size = new System.Drawing.Size(712, 461);
            this.MyGrid.SmartSizeBox = false;
            this.MyGrid.TabIndex = 0;
            this.MyGrid.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.MyGrid_QueryColCount);
            this.MyGrid.CellClick += new Syncfusion.Windows.Forms.Grid.GridCellClickEventHandler(this.MyGrid_CellClick);
            this.MyGrid.CellDrawn += new Syncfusion.Windows.Forms.Grid.GridDrawCellEventHandler(this.MyGrid_CellDrawn);
            this.MyGrid.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.MyGrid_QueryRowCount);
            this.MyGrid.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(this.MyGrid_QueryCellInfo);
            this.MyGrid.CurrentCellValidating += new System.ComponentModel.CancelEventHandler(this.MyGrid_CurrentCellValidating);
            //this.MyGrid.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(this.MyGrid_SaveCellInfo);
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.button1);
            this.panel1.Controls.Add(this.MyGrid);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(712, 461);
            this.panel1.TabIndex = 0;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(432, 320);
            this.button1.Name = "button1";
            this.button1.TabIndex = 1;
            this.button1.Text = "button1";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(712, 461);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.MyGrid)).EndInit();
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Form1_Load(object sender, System.EventArgs e)
        {
            ParseInformationXML();

            MyGrid.Cols.Hidden[0] = true;
            MyGrid.AllowSelection = GridSelectionFlags.Cell;
            MyGrid.CurrentCellValidating += new CancelEventHandler(MyGrid_CurrentCellValidating);
            MyGrid.CurrentCellActivated +=new EventHandler(MyGrid_CurrentCellActivated);

            MyGrid.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll;
            MyGrid.ForceCurrentCellMoveTo = true;
            MyGrid.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.HideAlways;
            MyGrid.RefreshCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridRefreshCurrentCellBehavior.RefreshRow;
            MyGrid.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.AlwaysVisible;
            //Add cell model for date time picker which will display the joining date of employees
            MyGrid.CellModels.Add("DateTimePicker", new DateTimeCellModel(MyGrid.Model));
            MyGrid.ResetVolatileData();

            m_InfoList.Sort();
            MyGrid.Refresh();
            MyGrid.CurrentCell.MoveTo(10,2);
        }

        #region Grid EventHandlers

        private void MyGrid_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            //Virtual grid does not actually contain the data. It is just a reflection of the data. 
            //Hence we populate the rows at run time based on the current focus of the grid


            //This event is overridden to populate the cell values that are currently in focus.
            //The event arguments will provide the column and row index of the cell that needs to be populated
            if (e.RowIndex < 0)
                return;


            //set the column headers that come in row 0.
            if (e.RowIndex == 0)
            {
                switch (e.ColIndex)
                {
                    case 1 : e.Style.CellValue = "Employee Name";
                        break;
                    case 2 : e.Style.CellValue = "Employee Num";
                        break;
                    case 3 : e.Style.CellValue = "Joining Date";
                        break;
                    default : e.Style.CellValue = string.Empty;
                        break;
                }
                return;
            }
            
            //For the rest of the rows, get the value from the member list
            string cellValue = GetCellValue(e.RowIndex - 1, e.ColIndex);

            if (e.ColIndex != 3) //not the third column which happens to be a date-time column
            {
                e.Style.CellValue = cellValue;
            }   
            else
            {
                e.Style.CellType = "TextBox";
                e.Style.CellValueType = typeof(string);
                e.Style.Format = "";
                e.Style.CellValue = "";

                e.Style.CellType = "DateTimePicker";
                e.Style.CellValueType = typeof(DateTime);
                e.Style.Format = "HH:mm:ss dd-MMM-yyyy";
                e.Style.CellValue = DateTime.ParseExact(cellValue,"HH:mm:ss dd-MMM-yyyy",null, DateTimeStyles.AllowWhiteSpaces);
            }
            //This statement just tries to illustrate the fact that all rows are not populated all the time.
            //Run this in debug and check the output window while performing scroll operations on the grid.
//            System.Diagnostics.Debug.WriteLine(e.RowIndex);

            System.Diagnostics.Debug.WriteLine("MyGrid_QueryCellInfo");
            e.Handled = true;
        }

        private void MyGrid_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
        {
            e.Handled = true;
        }

        private void MyGrid_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            //as part of the virtual grid concept, we need to make override this method and set the number of columns
            e.Count = 3;
            e.Handled = true;
        }

        private void MyGrid_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            //as part of the virtual grid concept, we need to make override this method and set the total number of rows.
            e.Count = m_InfoList.Count - 1;
            e.Handled = true;
        }
        
        private void MyGrid_CellClick(object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e)
        {
            //This method handles the sorting of the grid.
            //Clicking on the columns headers will set the descending/ascending order of the grid
            if (e.RowIndex == 0)
            {
                //Set the sorting column and descending/ascending flag
                m_InfoList.SortKey = (SortKey_t)(e.ColIndex - 1);
                m_InfoList.SortAsc = m_InfoList.SortAsc ? false: true;
                
                //sort the list and refresh the grid
                m_InfoList.Sort();
                MyGrid.Refresh();
            }
        }
        private void MyGrid_CellDrawn(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellEventArgs e)
        {
            //draw arrow pictures to depict the sort direction

        }

        
        private void MyGrid_CurrentCellAcceptedChanges(object sender, System.ComponentModel.CancelEventArgs e)
        {
            int row = MyGrid.CurrentCell.RowIndex;
            int col = MyGrid.CurrentCell.ColIndex;
//            System.Diagnostics.Debug.WriteLine("accepted changes call");
            
            if (row > 0)
            {
                string newValue = MyGrid.CurrentCell.Renderer.ControlText;
                switch(col)
                {
                    case 1: 
                        m_InfoList[row - 1].EmployeeName = newValue;
                        break;
                    case 2: 
                        m_InfoList[row - 1].EmployeeNum = newValue;
                        break;
                    case 3: 
                        newValue = MyGrid[row, col].CellValue.ToString();
                        newValue = DateTime.Parse(newValue).ToString("HH:mm:ss dd-MMM-yyyy");
                        m_InfoList[row - 1].JoiningDate = newValue;
                        break;
                    default: break;
                }
            }
        }
        #endregion Grid EventHandlers

        #region Data Handling
        private string GetCellValue(int row, int col)
        {
            RecordStruct empStruct = m_InfoList[row] as RecordStruct;
            switch(col)
            {
                case 1: return empStruct.EmployeeName;
                case 2: return empStruct.EmployeeNum;
                case 3: return empStruct.JoiningDate;
                default: return string.Empty;
            }
        }
        
        private void ParseInformationXML()
        {
            XmlDocument xmlDoc = new XmlDocument();
            XmlNode tmpNode = null;

            xmlDoc.Load(@"..\..\Information.xml");
            m_InfoList.Clear();

            XmlNodeList nodeList = xmlDoc.GetElementsByTagName("Record");
            foreach (XmlNode node in nodeList)
            {
                RecordStruct empStruct = new RecordStruct();

                empStruct.EmployeeName = ((tmpNode = node["EmployeeName"])!= null ? tmpNode.InnerText : string.Empty);
                empStruct.EmployeeNum = ((tmpNode = node["EmployeeNum"])!= null ? tmpNode.InnerText : string.Empty);
                empStruct.JoiningDate = ((tmpNode = node["JoiningDate"])!= null ? tmpNode.InnerText : string.Empty);

                m_InfoList.AddRecord(empStruct);
            }
        }
        #endregion Data Handling

        private void MyGrid_CurrentCellValidating(object sender, CancelEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("MyGrid_CurrentCellValidating");
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            //ParseInformationXML();
            //MyGrid[1,2].CellValue = "srivi1";
            //MyGrid[3,3].CellValue = "srivi";          
  
            for (int i = 1 ; i < 100 ; i++)
            {
                string cellValue = GetCellValue(i, 3);
                MyGrid[i, 3].CellType = "DateTimePicker";
                MyGrid[i, 3].CellValueType = typeof(DateTime);
                MyGrid[i, 3].Format = "HH:mm:ss dd-MMM-yyyy";
                MyGrid[i, 3].CellValue = DateTime.ParseExact(cellValue,"HH:mm:ss dd-MMM-yyyy",null, DateTimeStyles.AllowWhiteSpaces);
            }
        }

        private void MyGrid_CurrentCellActivated(object sender, EventArgs e)
        {

        }
    }

    public class RecordStruct
    {
        public string EmployeeName;
        public string EmployeeNum;
        public string JoiningDate;

        public RecordStruct()
        {
            EmployeeName = string.Empty;
            EmployeeNum = string.Empty;
            JoiningDate = string.Empty;
        }
    }

    /// <summary>
    /// This class stores the data objects. Derived from IComparer, the objects can be sorted on any key [name, number,
    /// joining date].
    /// </summary>
    public class MyList : IComparer
    {
        private ArrayList m_InfoList = new ArrayList();
        public SortKey_t SortKey = SortKey_t.SORT_KEY_NAME;
        public bool SortAsc = true;

        public MyList()
        {
            //empty constructor
        }

        public void AddRecord(RecordStruct empStruct)
        {
            m_InfoList.Add(empStruct);
        }

        public void Clear()
        {
            m_InfoList.Clear();
        }
        public RecordStruct this[int index]
        {
            get
            {
                //overriden indexer to return the record structure
                return m_InfoList[index] as RecordStruct;
            }
        }
        public int Count
        {
            get
            {
                return m_InfoList.Count;
            }
        }
        public int Compare(object a, object b)
        {
            //ICompare uses this method to override the sorting method.
            //Here we are sorting based on the sort key and SortAscending flag
            RecordStruct emp1 = a as RecordStruct;
            RecordStruct emp2 = b as RecordStruct;
            switch (SortKey)
            {
                case SortKey_t.SORT_KEY_NAME: 
                    return (SortAsc ? emp1.EmployeeName.CompareTo(emp2.EmployeeName) : emp2.EmployeeName.CompareTo(emp1.EmployeeName));
                case SortKey_t.SORT_KEY_NUM: 
                    return (SortAsc ? emp1.EmployeeNum.CompareTo(emp2.EmployeeNum): emp2.EmployeeNum.CompareTo(emp1.EmployeeNum));
                case SortKey_t.SORT_KEY_DATE: 
                    DateTime dt = DateTime.ParseExact(emp1.JoiningDate,"HH:mm:ss dd-MMM-yyyy",null, DateTimeStyles.AllowWhiteSpaces);
                    double index1 = dt.ToOADate();
                    dt = DateTime.ParseExact(emp2.JoiningDate,"HH:mm:ss dd-MMM-yyyy",null, DateTimeStyles.AllowWhiteSpaces);
                    double index2 = dt.ToOADate();                    
                    if (SortAsc)
                    {
                        return (int)Math.Ceiling(index1 - index2);
                    }
                    else
                    {
                        return (int)Math.Ceiling(index2 - index1);
                    }
                default: return 0;
            }
        }

        public void Sort()
        {
            m_InfoList.Sort(this as IComparer);
        }


    }

    public enum SortKey_t
    {
        SORT_KEY_NAME,
        SORT_KEY_NUM,
        SORT_KEY_DATE
    }
    public class DummyEventArgs
    {
        public string data;
    }
}
